Index: chan_skinny.c
===================================================================
--- chan_skinny.c	(revision 44249)
+++ chan_skinny.c	(working copy)
@@ -1347,7 +1347,7 @@
 
 	memset(s->outbuf,0,sizeof(s->outbuf));
 	memcpy(s->outbuf, req, skinny_header_size);
-	memcpy(s->outbuf+skinny_header_size, &req->data, sizeof(union skinny_data));
+	memcpy(s->outbuf+skinny_header_size, &req->data, letohl(req->len));
 
 	res = write(s->fd, s->outbuf, letohl(req->len)+8);
 	if (res != letohl(req->len)+8) {
@@ -1748,14 +1748,13 @@
 		return RESULT_SHOWUSAGE;
 	}
 	ast_mutex_lock(&devicelock);
-
 	for (d = devices; d; d = d->next) {
 		int fullrestart = 0;
 		if (!strcasecmp(argv[2], d->id) || !strcasecmp(argv[2], "all")) {
 			if (!(d->session))
 				continue;
 
-			if (!(req = req_alloc(sizeof(struct reset_message), RESET_MESSAGE)))
+			if (!(req = req_alloc(sizeof(struct reset_message), RESET_MESSAGE))) 
 				continue;
 
 			if (argc == 4 && !strcasecmp(argv[3], "restart"))
@@ -2176,6 +2175,7 @@
 				ast_log(LOG_WARNING, "Cannot get socket name\n");
 				sin.sin_addr = __ourip;
 			}
+			
 			d->ourip = sin.sin_addr;
 			break;
 		}
@@ -2196,8 +2196,11 @@
 	if (d) {
 		d->session = NULL;
 		d->registered = 0;
+		/* remove from device list  or set as unregister */
+		
 	}
 
+
 	return -1; /* main loop will destroy the session */
 }
 
@@ -3608,6 +3611,7 @@
 	struct skinny_device *d = s->device;
 	struct skinny_line *l;
 	struct skinny_subchannel *sub;
+	struct skinny_req *req_local;
 	struct ast_format_list fmt;
 	struct sockaddr_in sin;
 	struct sockaddr_in us;
@@ -3649,26 +3653,27 @@
 		ast_verbose("ourip = %s:%d\n", ast_inet_ntoa(d->ourip), ntohs(us.sin_port));
 	}
 
-	if (!(req = req_alloc(sizeof(struct start_media_transmission_message), START_MEDIA_TRANSMISSION_MESSAGE)))
+	if (!(req_local = req_alloc(sizeof(struct start_media_transmission_message),START_MEDIA_TRANSMISSION_MESSAGE)))
 		return -1;
-
+	
 	fmt = ast_codec_pref_getsize(&l->prefs, ast_best_codec(l->capability));
 
 	if (skinnydebug)
 		ast_verbose("Setting payloadType to '%d' (%d ms)\n", fmt.bits, fmt.cur_ms);
 
-	req->data.startmedia.conferenceId = htolel(0);
-	req->data.startmedia.passThruPartyId = htolel(sub->callid);
-	req->data.startmedia.remoteIp = htolel(d->ourip.s_addr);
-	req->data.startmedia.remotePort = htolel(ntohs(us.sin_port));
-	req->data.startmedia.packetSize = htolel(fmt.cur_ms);
-	req->data.startmedia.payloadType = htolel(codec_ast2skinny(fmt.bits));
-	req->data.startmedia.qualifier.precedence = htolel(127);
-	req->data.startmedia.qualifier.vad = htolel(0);
-	req->data.startmedia.qualifier.packets = htolel(0);
-	req->data.startmedia.qualifier.bitRate = htolel(0);
-	transmit_response(s, req);
+	req_local->data.startmedia.conferenceId = htolel(0);
+	req_local->data.startmedia.passThruPartyId = htolel(sub->callid);
+	req_local->data.startmedia.remoteIp = htolel(d->ourip.s_addr);
+	req_local->data.startmedia.remotePort = htolel(ntohs(us.sin_port));
+	req_local->data.startmedia.packetSize = htolel(fmt.cur_ms);
+	req_local->data.startmedia.payloadType = htolel(codec_ast2skinny(fmt.bits));
+	req_local->data.startmedia.qualifier.precedence = htolel(127);
+	req_local->data.startmedia.qualifier.vad = htolel(0);
+	req_local->data.startmedia.qualifier.packets = htolel(0);
+	req_local->data.startmedia.qualifier.bitRate = htolel(0);
+	transmit_response(s, req_local);
 
+	free(req_local);
 	return 1;
 }
 
